/****************************************************************************
mdiskltn.c - A Open32 and Win32 Common Source Code(Source File)
        Open32Win32̋ʃ\[XR[h
produced by Y.Yoshida
*****************************************************************************/
#ifdef OPEN32
#include <os2win.h>
#else
#include <windows.h>
#include <imm.h>
#endif

#include <stdio.h>
#include <string.h>
#include "resource.h"
#include "mdiskltn.h"

char    szAppName[] = "MDISkelton";
char    szDocName[] = "Document";
HANDLE  hInst;
HWND    hwndMain      = NULL;
HWND    hwndMDIClient = NULL;
HWND    hwndActive    = NULL;

HANDLE  hAccelTable;
HFONT   hFontH, hFontV;

LRESULT CALLBACK MainWndProc(HWND hwnd,
                             UINT msg,
                             WPARAM wParam, LPARAM lParam);

BOOL CALLBACK AboutDlgProc(HWND hwnd,
                                UINT msg,
                                WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DocWndProc(HWND hwnd,
                            UINT msg,
                            WPARAM wParam, LPARAM lParam);
HWND PASCAL CreateTextWindow(LPSTR lpName, int iDocStyle);

/*------------------------------------------------------------------
  WinMain

--------------------------------------------------------------------*/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpszCmdLine, int nCmdshow)
{
  WNDCLASS wndclass;
  MSG      msg;
  
  if(!hPrevInstance)
    {
    /* CEEBhẼNXo^ */
    wndclass.style         = 0;
    wndclass.lpfnWndProc   = MainWndProc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;
    wndclass.hInstance     = hInstance;
    wndclass.hIcon         = LoadIcon(hInstance,
                                      MAKEINTRESOURCE(IDI_SKELTON));
    wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground = GetStockObject(WHITE_BRUSH); 
    wndclass.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU);
    wndclass.lpszClassName = szAppName;
    if(!RegisterClass(&wndclass))
      return(FALSE);
    /* qEBhẼNXo^ */
    wndclass.lpfnWndProc   = DocWndProc;
    wndclass.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_DOC));
    wndclass.lpszMenuName  = NULL;
    wndclass.cbWndExtra    = sizeof(HANDLE);
    wndclass.lpszClassName = szDocName;
    if(!RegisterClass(&wndclass))
      return(FALSE);
    }
  hInst = hInstance;
#ifdef OPEN32
  hwndMain = CreateWindowEx(0,
#else
  hwndMain = CreateWindowEx(WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE,
#endif
                            szAppName,
                            "MDI Skelton Program",
                            WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                            CW_USEDEFAULT, 0,
                            CW_USEDEFAULT, 0,
                            HWND_DESKTOP,
                            NULL,
                            hInst,
                            NULL);
  if(!hwndMain || !hwndMDIClient)
    return(FALSE);
  
  hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCEL));
  
  ShowWindow(hwndMain, nCmdshow);
  UpdateWindow(hwndMain);
  
  while(GetMessage(&msg, NULL, 0, 0))
       {
       if(!TranslateMDISysAccel(hwndMDIClient, &msg) &&
          !TranslateAccelerator(hwndMain, hAccelTable, &msg))
         {
         TranslateMessage(&msg);
         DispatchMessage(&msg);
         }
       }
  return(msg.wParam);
}


/*------------------------------------------------------------------
  MainWndProc

--------------------------------------------------------------------*/
LRESULT CALLBACK MainWndProc(HWND hwnd,
                             UINT msg,
                             WPARAM wParam, LPARAM lParam)
{
  RECT  rClient;
  
  switch(msg)
        {
        default:
             return (DefFrameProc(hwnd, hwndMDIClient,
                                        msg, wParam, lParam));
        case WM_CREATE:
             {
             CLIENTCREATESTRUCT ccs;
             
             ccs.hWindowMenu  = GetSubMenu(GetMenu(hwnd), 1);
             ccs.idFirstChild = IDM_WINDOW_CHILDREN;
             /* MDINCAgEBhE̍쐬 */
             hwndMDIClient = CreateWindow("mdiclient",
                                          NULL,
                                          WS_CHILD,
                                          0, 0, 0, 0,
                                          hwnd,
                                          (HMENU)0xcac,
                                          hInst,
                                          (LPVOID)&ccs);
             ShowWindow(hwndMDIClient, SW_SHOW);
             
#ifdef OPEN32
             hFontH  = CreateFont(24, 0, 0, 0,
                                  FW_BOLD, FALSE, FALSE, FALSE,
                                  SHIFTJIS_CHARSET,
                                  OUT_DEFAULT_PRECIS,
                                  CLIP_DEFAULT_PRECIS,
                                  DEFAULT_QUALITY,
                                  DEFAULT_PITCH | FF_ROMAN,
                                  "Helv Combined");
             hFontV  = CreateFont(24, 0, 2700, 0,
                                  FW_NORMAL, FALSE, FALSE, FALSE,
                                  SHIFTJIS_CHARSET,
                                  OUT_DEFAULT_PRECIS,
                                  CLIP_DEFAULT_PRECIS,
                                  DEFAULT_QUALITY,
                                  DEFAULT_PITCH | FF_ROMAN,
                                  "@HeiseiMincho-W3-90-TT");
#else
             hFontH  = CreateFont(24, 0, 0, 0,
                                  FW_BOLD, FALSE, FALSE, FALSE,
                                  SHIFTJIS_CHARSET,
                                  OUT_DEFAULT_PRECIS,
                                  CLIP_DEFAULT_PRECIS,
                                  DEFAULT_QUALITY,
                                  DEFAULT_PITCH | FF_ROMAN,
                                  "lr o");
             hFontV  = CreateFont(24, 0, 2700, 0,
                                  FW_NORMAL, FALSE, FALSE, FALSE,
                                  SHIFTJIS_CHARSET,
                                  OUT_DEFAULT_PRECIS,
                                  CLIP_DEFAULT_PRECIS,
                                  DEFAULT_QUALITY,
                                  DEFAULT_PITCH | FF_ROMAN,
                                  "@lr o");
#endif
             break;
             }
        case WM_COMMAND:
             switch(wParam)
                   {
                   default:
                        return(DefFrameProc(hwnd, hwndMDIClient,
                                                  msg,
                                                  wParam, lParam));
                   case IDM_HORIZONTAL:
                        CreateTextWindow(NULL, DOC_HORIZONTAL);
                        break;
                   case IDM_VERTICAL:
                        CreateTextWindow(NULL, DOC_VERTICAL);
                        break;
                   case IDM_IM32:
                        {
                        HIMC  hImc;
                        BOOL  fOn;
                        
                        hImc = ImmGetContext(GetFocus());
                        fOn  = ImmGetOpenStatus(hImc);
                        ImmSetOpenStatus(hImc, !fOn);
                        ImmReleaseContext(GetFocus(), hImc);
                        }
                        break;
                   case IDM_WINDOW_TILE:
                        SendMessage(hwndMDIClient, WM_MDITILE, 0, 0L);
                        break;
                   case IDM_WINDOW_CASCADE:
                        SendMessage(hwndMDIClient, WM_MDICASCADE, 0, 0L);
                        break;
                   case IDM_WINDOW_ICONS:
                        SendMessage(hwndMDIClient, WM_MDIICONARRANGE, 0, 0L);
                        break;
                   case IDM_ABOUT:
                        DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUT),
                                         hwnd,
                                         AboutDlgProc);
                        break;
                   }
        case WM_SIZE:
             GetClientRect(hwnd, &rClient);
             MoveWindow(hwndMDIClient,
                        rClient.left,
                        rClient.top,
                        rClient.right - rClient.left,
                        rClient.bottom - rClient.top,
                        TRUE);
             break;
        case WM_DESTROY:
             DeleteObject(hFontH);
             DeleteObject(hFontV);
             PostQuitMessage(0);
             break;
        }
  return(TRUE);
}


/*------------------------------------------------------------------
  CreateTextWindow

--------------------------------------------------------------------*/
HWND PASCAL CreateTextWindow(LPSTR lpName, int iDocStyle)
{
  HWND hwnd;
  char szBuf[160];
  MDICREATESTRUCT mcs;
  
  static int nChildren = 1;
  
  if(!lpName)
    {
    sprintf(szBuf, "(Untitled - %d)", nChildren++);
    mcs.szTitle = (LPSTR)szBuf;
    }
  else
    mcs.szTitle = lpName;
  
  mcs.szClass    = szDocName;
  mcs.hOwner     = hInst;
  mcs.x = mcs.cx = CW_USEDEFAULT;
  mcs.y = mcs.cy = CW_USEDEFAULT;
  mcs.style      = 0;
  mcs.lParam     = (LPARAM)iDocStyle;
  hwnd = (HWND)SendMessage(hwndMDIClient,
                           WM_MDICREATE,
                           0, (LONG)(LPMDICREATESTRUCT)&mcs);
  return(hwnd);
}


PSTR  szTextLines[] =
      {
      "",
      "OS/2 Warp J4.0 Open32vO~O",
      "",
      "MDĨXPgEvOɂWin32Open32Ƃ",
      "ʃ\[XER[hɂẴTvłB",
      "",
      "܂AV[U[C^tF[XɂȂ32bit{",
      "̓VXeIM32Imm APIł̎gpɂȂĂ܂B"
      };
int clTextLines = 8;


/*------------------------------------------------------------------
  OutTextHorz

--------------------------------------------------------------------*/
void OutTextsHorz(HWND hwnd, HDC hDC)
{
  TEXTMETRIC  tmFontInfo;
  int         x, y, i, LineHeight;
  HFONT       hOldFont;
  
  SetTextColor(hDC, RGB(0, 0, 255));
  hOldFont = SelectObject(hDC, hFontH);
  GetTextMetrics(hDC, &tmFontInfo);
  x = 4 * tmFontInfo.tmAveCharWidth;
  y = tmFontInfo.tmExternalLeading +
      tmFontInfo.tmInternalLeading;
  LineHeight = y + tmFontInfo.tmHeight;
  for(i = 0; i < clTextLines; i++)
     {
     TextOut(hDC, x, y,
                  szTextLines[i],
                  strlen(szTextLines[i]));
     y += LineHeight;
     }
  SelectObject(hDC, hOldFont);
}


/*------------------------------------------------------------------
  OutTextVert

--------------------------------------------------------------------*/
void OutTextsVert(HWND hwnd, HDC hDC)
{
  TEXTMETRIC  tmFontInfo;
  int         x, y, i, LineHeight;
  HFONT       hOldFont;
  RECT        rect;
  
  GetClientRect(hwnd, &rect);
  SetTextColor(hDC, RGB(0, 255, 0));
  hOldFont = SelectObject(hDC, hFontV);
  GetTextMetrics(hDC, &tmFontInfo);
  y = 4 * tmFontInfo.tmAveCharWidth;
  x = rect.right - (tmFontInfo.tmExternalLeading +
                    tmFontInfo.tmInternalLeading);
  LineHeight = tmFontInfo.tmExternalLeading +
               tmFontInfo.tmInternalLeading +
               tmFontInfo.tmHeight;
  for(i = 0; i < clTextLines; i++)
     {
     TextOut(hDC, x, y,
                  szTextLines[i],
                  strlen(szTextLines[i]));
     x -= LineHeight;
     }
  SelectObject(hDC, hOldFont);
}


/*------------------------------------------------------------------
  DocWndProc

--------------------------------------------------------------------*/
LRESULT CALLBACK DocWndProc(HWND hwnd,
                            UINT msg,
                            WPARAM wParam, LPARAM lParam)
{
  PAINTSTRUCT ps;
  static HDC         hDC, hMemDC;
  static HBITMAP     hBmp;
  static HBRUSH      hBrush;
  
  switch(msg)
        {
        default:
             return(DefMDIChildProc(hwnd, msg, wParam, lParam));
        case WM_CREATE:
             {
             LPCREATESTRUCT    lpCS;
             LPMDICREATESTRUCT lpMDICS;
             
             lpCS = (LPCREATESTRUCT)lParam;
             lpMDICS = (LPMDICREATESTRUCT)lpCS->lpCreateParams;
             SetProp(hwnd, "WStyle", (HANDLE)lpMDICS->lParam);
             
             SetFocus(hwnd);
             }
             break;
        case WM_DESTROY:
             RemoveProp(hwnd, "WStyle");
             DeleteDC(hMemDC);
             return(DefMDIChildProc(hwnd, msg, wParam, lParam));
        case WM_PAINT:
             {
             int WritingStyle;
             
             hDC = BeginPaint(hwnd, &ps);
             WritingStyle = (int)GetProp(hwnd, "WStyle");
             if(WritingStyle == DOC_HORIZONTAL)
               OutTextsHorz(hwnd, hDC);
             else
               OutTextsVert(hwnd, hDC);
             EndPaint(hwnd, &ps);
             }
             break;
        case WM_MDIACTIVATE:
             hwndActive = (wParam) ? hwnd : NULL;
             break;
        case WM_SETFOCUS:
             CreateCaret(hwnd, NULL, 1, 12);
             SetCaretPos(10, 20);
             ShowCaret(hwnd);
             break;
        case WM_KILLFOCUS:
             DestroyCaret();
             break;
        }
  return(FALSE);
}

/*------------------------------------------------------------------
  AboutDlgProc

--------------------------------------------------------------------*/
BOOL CALLBACK AboutDlgProc(HWND hwnd,
                           UINT msg,
                           WPARAM wParam, LPARAM lParam)
{
  switch(msg)
        {
        default:
             break;
        case WM_COMMAND:
             if(wParam == IDOK || wParam == IDCANCEL)
               {
               EndDialog(hwnd, TRUE);
               return (TRUE);
               }
             break;
        }
  return(FALSE);
}
